//enable global error handler
// window.onerror = function(msg, url, line){
// 	ui.fail_handler('Unhandled JavaScript error: [LINE ' + line + '] of [' + url + ']; Caller: ' + arguments.callee.caller.name, msg);
// 	return true;
// };

var isPhonegap = function(){
	return typeof window.device !== 'undefined';
};
var isIOS = function(){
	return window.device && window.device.platform && window.device.platform === 'iOS';
};
var isAndroid = function(){
	return window.device && window.device.platform && window.device.platform === 'Android';
};

//see heading "More Tips and Tricks" here:
// http://jquerymobile.com/demos/1.2.0/docs/pages/phonegap.html
$.mobile.pushStateEnabled = false;

//transition instantly instead of with a delay
$.mobile.buttonMarkup.hoverDelay = 0;
$.mobile.defaultPageTransition = 'none';

/*
 * API Settings
 */
var api = api || {};
// api.baseurl = 'http://stage-cornell.alumniq.com/api/mobile/2014/index.cfm';
// api.baseurl = 'http://cornell.local/api/mobile/2014/index.cfm';
api.baseurl = 'http://reunion-registration.alumni.cornell.edu/api/mobile/2014/index.cfm';

api.send = function(verb, resource, data, success, fail){
	// console.log(verb, api.baseurl + resource, data);
	$.ajax({
		url: api.baseurl + resource
		,type: verb
		,data: data
		,dataType: 'json'
		,encoding: 'UTF-8'
		,success: success
		,error: fail
		,complete: function(xhr){
			// console.log(xhr);
		}
		,crossDomain: true
		,cache: false
	});
};

api.get = function(resource, data, success, fail){
	api.send('GET', resource, data, success, fail);
};

api.post = function(resource, data, success, fail){
	api.send('POST', resource, data, success, fail);
};

api.put = function(resource, data, success, fail){
	api.send('PUT', resource, data, success, fail);
};

api.delete = function(resource, data, success, fail){
	console.log('DELETE', api.baseurl + resource, data);
	$.ajax({
		url: api.baseurl + resource
		,type: 'POST'
		,data: data
		,headers: {
			'X-HTTP-Method-Override': 'DELETE'
		}
		,dataType: 'json'
		,encoding: 'UTF-8'
		,success: success
		,error: fail
		,complete: function(xhr){
			console.log(xhr);
		}
		,crossDomain: true
		,cache: false
	});
};

/*
 * SOCIAL STUFF
 */
var social = social || {};
social.mine = function( data ){
	api.put(
		'/people/'+app.personId+'/social'
		,data
		,function(response){/* all's well that ends well */}
		,function(jqXHR,textStatus,error){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'social.mine');
		}
	);
};

social.twitter = {
	consumerKey: 'ElvgE7sNe0MTfZoAJ2avMw'
	,consumerSecret: 'DqgggOtcbw5F6FwzCYebWxWOBqKkfRpTtBUiJ7fTgU'
	,oauthCallback: 'http://cornell.alumnione.com/oauth/twitter'
	,hashtag: '#CUReunion'
	,user: null
	,twitter: null
};
social.twitter.init = function(){
	social.twitter.twitter = new Twitter(
		social.twitter.oauthCallback
		, social.twitter.consumerKey
		, social.twitter.consumerSecret
	);

	var storageKey = '_TWITTER_';
	social.twitter.twitter.loadConfigVia(function(){
		var configFromDisk = localStorage.getItem(storageKey);
		if (configFromDisk) return JSON.parse(configFromDisk);
		return null;
	}).persistConfigVia(function(config){
		localStorage.setItem(storageKey, JSON.stringify(config));
	});

	//if user has already authenticated twitter, display twitter username
	if (social.twitter.user !== null){
		social.twitter.displayUser( social.twitter.user );
	}
};
social.twitter.login = function(){
	$.mobile.loading('show');
	social.twitter.twitter.login( social.twitter.onLogin );
};
social.twitter.onLogin = function( user ){
	$.mobile.loading('hide');
	if (user === null){
		return toastr.error('Error connecting to Twitter');
	}
	toastr.success('Twitter Connected');
	social.twitter.user = user;
	social.twitter.displayUser( user );
	app.saveSocial();

	//capture all twitter account info
	social.mine({
		tw_userid:         social.twitter.user.user_id
		,tw_username:      encodeURIComponent(social.twitter.user.screen_name)
		,tw_oauth_token:   encodeURIComponent(social.twitter.user.oauth_token)
		,tw_oauth_secret:  encodeURIComponent(social.twitter.user.oauth_token_secret)
		,tw_blob:          encodeURIComponent(JSON.stringify(social.twitter.user))
	});
};
social.twitter.displayUser = function( user ){
	if (user === null){
		$("#connections .well.twitter").addClass('incomplete').removeClass('complete');
	}else{
		$("#connections .well.twitter").removeClass('incomplete').addClass('complete');
		$("#connections .well.twitter .detail").html('@'+user.screen_name).show();
		$("#connections .well.twitter .explained").hide();
		$("#myProfile .connections #twitterLogin").addClass('connected');
	}
};
social.twitter.tweet = function(msg, cb){
	//append the hashtag if it's not already included and there's still room for it
	if (msg.toLowerCase().indexOf(social.twitter.hashtag.toLowerCase()) === -1 && msg.length < 139-social.twitter.hashtag.length){
		msg = msg + ' ' + social.twitter.hashtag;
	}

	social.twitter.twitter.tweet(msg, cb);
};


social.linkedin = {
	consumerKey: '77d1xvk3tb5ilf'
	,consumerSecret: 'clMtx6HpxezkH9Md'
	,oauthCallback: 'http://cornell.alumnione.com/oauth/linkedin'
	,group: '958'
	,permissions: 'r_basicprofile r_emailaddress'
	,user: null
	,linkedin: null
	,declinedGroup: false
};
social.linkedin.init = function(){
	social.linkedin.linkedin = new Linkedin(
		social.linkedin.oauthCallback
		, social.linkedin.consumerKey
		, social.linkedin.consumerSecret
	);

	//specify persistence (will cause any persisted data to be loaded)
	var storageKey = '_LINKEDIN_';
	social.linkedin.linkedin.loadConfigVia(function(){
		var configFromDisk = localStorage.getItem(storageKey);
		if (configFromDisk) return JSON.parse(configFromDisk);
		return null;
	}).persistConfigVia(function(config){
		localStorage.setItem(storageKey, JSON.stringify(config));
	});

	if (social.linkedin.user !== null){
		social.linkedin.displayUser( social.linkedin.user );
		$("body").addClass('li_connected');
	}else{
		$("body").addClass('li_disconnected');
	}
};
social.linkedin.login = function(){
	$.mobile.loading('show');
	social.linkedin.linkedin.login( social.linkedin.permissions, social.linkedin.onLogin );
};
social.linkedin.onLogin = function( user ){
	$.mobile.loading('hide');
	if (user === null){
		return toastr.error('Error connecting to LinkedIn');
	}
	toastr.success('LinkedIn Connected');
	social.linkedin.user = user;
	social.linkedin.displayUser( user );
	app.saveSocial();
	$("body").addClass('li_connected').removeClass('li_disconnected');

	//mine linkedin data
	social.mine({
		li_userid:               social.linkedin.user.id
		,li_email:               encodeURIComponent(social.linkedin.user.emailAddress)
		,li_profileUrl:          encodeURIComponent(social.linkedin.user.publicProfileUrl)
		,li_firstname:           encodeURIComponent(social.linkedin.user.firstName)
		,li_lastname:            encodeURIComponent(social.linkedin.user.lastName)
		,li_oauth_access_token:  encodeURIComponent(social.linkedin.linkedin.getToken())
		,li_blob:                encodeURIComponent(JSON.stringify(social.linkedin.user))
	});
};
social.linkedin.displayUser = function( user ){
	if (!user){
		$("#connections .well.linkedin").addClass('incomplete').removeClass('complete');
	}else{
		$("#connections .well.linkedin").removeClass('incomplete').addClass('complete');
		$("#connections .well.linkedin .detail").html(user.firstName + ' ' + user.lastName).show();
		$("#connections .well.linkedin .explained").hide();
	}
};

social.facebook = {
	appid: '232556086931840'
	,user: null
	,facebook: null
};
social.facebook.bindings = function(){
	if (typeof FB === 'undefined'){
		//todo: fall back to mobile-web social integration
		return;
	}
	FB.Event.subscribe('auth.login', function(response) {
		console.log('FACEBOOK LOGIN: ', response);
		//get user details of logged in user
		social.facebook.onLogin();
	});

	FB.Event.subscribe('auth.logout', function(response) {
		console.log('FACEBOOK LOGOUT: ', response);
		social.facebook.onLogin();
	});

	FB.Event.subscribe('auth.sessionChange', function(response) {
		console.log('FACEBOOK SESSION CHANGE: ', response);
		social.facebook.onLogin();
	});

	FB.Event.subscribe('auth.authResponseChange', function(response) {
		console.log('FACEBOOK AUTH RESPONSE CHANGE: ', response);
		social.facebook.onLogin();
	});
};
social.facebook.init = function(){
	//FB not available on mobile web/testing
	if (typeof FB === 'undefined') return;

	social.facebook.bindings();

	FB.init({
		appId: social.facebook.appid
		,nativeInterface: CDV.FB
		,useCachedDialogs: false
		,status: true
		,xfbml: false
	});
	social.facebook.facebook = new Facebook();

	//attempt to get user info at startup
	// app_interface.facebook.getUserInfo(require('ui').facebook.updateUser);
};
social.facebook.login = function( scope ){
	scope = scope || 'basic_info,email,work,education';
	social.facebook.facebook.login(scope);
};
social.facebook.onLogin = function(){
	social.facebook.facebook.getUserInfo(function( error, fbUser ){
		if (error){
			return toastr.error('Error getting Facebook account information. Please try again later.');
		}

		social.facebook.user = fbUser;
		app.saveSocial();
		social.facebook.displayUser( fbUser );

		if (user){
			toastr.success('Facebook Connected');
		}
	});
};
social.facebook.displayUser = function( user ){
	if (user === null){
		$("#connections .well.facebook").addClass('incomplete').removeClass('complete');
	}else{
		$("#connections .well.facebook").removeClass('incomplete').addClass('complete');
		$("#connections .well.facebook .explained").hide();
		$("#connections .well.facebook .detail").html(user.first_name + ' ' + user.last_name).show();

		//mine social data
		// social.mine({
		// 	fb_id:            user.id
		// 	,fb_email:        encodeURIComponent(user.email)
		// 	,fb_profileUrl:   encodeURIComponent(user.link)
		// 	,fb_accessToken:  encodeURIComponent(FB.getAccessToken())
		// 	,fb_blob:         encodeURIComponent(JSON.stringify(user))
		// });
	}
};


/*
 * APP MODULE
 *
 * Handles data. Bitch.  <--- This must have been written during Breaking Bad
 */
var app = app || {};
app.disabled = true; //we twiddle this off as soon as everything is loaded
app.info = {}; //where we store identifying info about the device
app.build = '2.2.0'; //@@version
$(function(){ $(".appVersion").html('App Version: ' + app.build); });
app.announcementTimerFrequency = 1000 * 60 * 3; //3 minutes
app.diskCache = Apollo.init(api.baseurl, 30 * 60 * 1000);

app.getAnnouncements = function(){
	try {
		api.get(
			'/announcements.json'
			, null
			, function(data){
				ui.updateAnnouncements( data );
				// if (data.msg === ''){
				// 	app.currentAnnouncement = 'No announcements';
				// }else{
				// 	app.currentAnnouncement = data.msg;
				// }
				// ui.updateAnnouncement(app.currentAnnouncement);
			}
			, function(jqXHR, textStatus, errorThrown){
				// app.currentAnnouncement = 'Not able to load current announcement...';
				// ui.updateAnnouncement(app.currentAnnouncement);
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getCurrentAnnouncement');
			}
		);
	} catch(err) {
		// app.currentAnnouncement = 'Not able to load current announcement...';
		// ui.updateAnnouncement(app.currentAnnouncement);
		ui.fail_handler(err.message, 'app.getCurrentAnnouncement');
	}
};

app.getScheduleData = function(overrideCache, showDate, meridian, successCB, failCB){
	overrideCache = overrideCache || false;
	app.diskCache.get(
		'SESSIONS_' + showDate + meridian
		,'/sessions/' + showDate + '.json'
		, {
			meridian: meridian
		}
		, null //use default cache duration
		, overrideCache
		, function(data){
			successCB(data);
		}
		, function(jqXHR, textStatus, errorThrown){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getScheduleData');
			failCB(jqXHR.responseText);
		}
	);
};

app.getStreamData = function(successCB, failCB, since, before, maxRows){
	try {
		since = since || -1;
		before = before || -1;
		maxRows = maxRows || 30;
		api.get(
			'/activity.json'
			,{
				since_id: since
				, before_id: before
				, maxRows: maxRows
			}
			,function(data, textStatus, jqXHR){
				successCB(data);
			}
			,function(jqXHR, textStatus, errorThrown){
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getStreamData');
				failCB(jqXHR.responseText);
			}
		);
	} catch(err) {
		ui.fail_handler(err.message, 'app.getStreamData');
		failCB(err);
	}
};

app.getPeopleData = function(event, successCB, failCB, filter, group){
	filter = filter || '';
	try {
		api.get(
			'/people.json'
			, {
				filter: filter
				,searchGroup: group
			}
			, function(data, textStatus, jqXHR){
				successCB(data);
			}
			, function(jqXHR, textStatus, errorThrown){
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getPeopleData');
				failCB(jqXHR.responseText);
			}
		);
	} catch(err) {
		ui.fail_handler(err.message, 'app.getPeopleData');
		failCB(err);
	}
};

app.submitMsg = function(msg){
	app.queueMsg(app.info.device_id, msg);
}

/**
 * Party QR Codes
 */
app.getPartyQRCodes = function(successCB, failCB){
	app.diskCache.get('QRCODES', '/qrcodes', { personId: app.personId }, 100*60*5, false, function(data){
		successCB(data);
	}
	, function(jqXHR, textstatus, error){
		ui.fail_handler(jqXHR.responseText + '; ' + error, 'app.getPartyQRCodes');
		if (failCB) failCB(jqXHR.responseText);
	});
};

/**
 * Personal Schedule
 */
app.rawPersonalSchedule = [];
app.getMySchedule = function(successCB, failCB){
	/**
	* @TODO: read-through-cache for this data
	*/
	try {
		api.get(
			'/sessions/' + app.personId + '/all.json'
			, null
			, function(data) {
				app.rawPersonalSchedule = data;
				successCB(data);
			}
			, function(jqXHR, textStatus, errorThrown){
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getMySchedule');
				if (failCB) failCB(jqXHR.responseText);
			}
		);
	} catch(err) {
		ui.fail_handler(err.message, 'app.getMySchedule');
		failCB(err);
	}
};

app.getNextUp = function(successCB, failCB){
	var now = moment(new Date());
	var respond = function(){
		var found = _.find(
				app.rawPersonalSchedule
				, function(item){
					if (!item.hasOwnProperty('rawDate')) return false;
					//find the first item whose start time is no more than 15 minutes ago
					//~~ at 15 minutes into current session, display the NEXT session which I'll be attending
					var timediff = now.diff(moment(item.rawDate, "YYYYMMDDhhmmssa"), 'minutes');
					console.log('[%s] started %s minutes ago', item.title, timediff);
					return timediff <= 15;
				}
			)
			|| false;
		if (found){
			if (successCB) successCB(found);
		}else{
			if (failCB) failCB();
		}
	};
	if (app.rawPersonalSchedule.length === 0){
		app.getMySchedule(respond, null);
	}else{
		respond();
	}
};

app.removeSessionFromPersonalSchedule = function(sessionId, success, fail){
	$.mobile.loading( 'show' );
	api.get(
		'/sessions/' + app.personId + '/' + sessionId + '.json'
		, {
			delete: true
		}
		, function(data){
			$.mobile.loading( 'hide' );
			success();
		}
		, function(jqXHR, textStatus, errorThrown){
			$.mobile.loading( 'hide' );
			pgalert('Unable to delete bookmark. Please try again later.', 'Error');
			fail();
		}
	);
};

app.addSessionToPersonalSchedule = function(sessionId, success, fail){
	api.post(
		'/sessions/' + app.personId + '/' + sessionId + '.json'
		, null
		, function (data){
			success();
		}
		, function (jqXHR, textStatus, errorThrown){
			pgalert('Unable to send your change to the server. Please try again later.', 'API Error');
		}
	);
};

/**
 * Queue to make sure data is never lost
 */
app.sendQueue = {};
app.sendQueue.queue = JSON.parse(localStorage.getItem('sendQueue')) || [];
app.sendQueue.state = null;
app.sendQueue.frequency = 10 * 1000; //10 seconds

app.queueRating = function(personId, sessionId, rating){
	app.sendQueue.queue.push({
		type: 'rating'
		, personId: personId
		, sessionId: sessionId
		, rating: rating
	});
	app.persistQueue();
	app.processQueue();
};

app.queueTracking = function(device, location, meta){
	meta = meta || '';
	app.sendQueue.queue.push({
		type: 'tracking'
		, deviceId: device
		, location: location
		, clickTime: new Date().toString()
		, meta: meta
	});
	app.persistQueue();
	app.processQueue();
};

app.queueMsg = function(deviceId,msg){
	app.sendQueue.queue.push({
		type: 'streamMsg'
		, deviceId: deviceId
		, msg: msg
	});
	app.persistQueue();
	app.processQueue();
};

app.persistQueue = function(){
	localStorage.setItem('sendQueue', JSON.stringify(app.sendQueue.queue));
};

app.processQueue = function(isRecursing){
	isRecursing = isRecursing || false;

	//do nothing if the queue is empty
	// -- or, if the queue has just been drained, set the state back to null so that
	//    other threads can work on it in the future
	if (app.sendQueue.queue.length === 0) {
		app.sendQueue.state = null;
		return;
	}

	//prevent multiple threads from processing at the same time
	if (app.sendQueue.state !== null && !isRecursing) return;
	app.sendQueue.state = 'processing';

	var item = app.sendQueue.queue[0];
	if (item.type === 'rating'){
		//send to session eval resource
		api.post(
			'/sessions/' + item.sessionId + '/evaluations.json'
			, {
				personId: item.personId
				, rating: item.rating
			}
			, function(data, textStatus, jqXHR){
				//drop the first element in the queue
				app.sendQueue.queue.shift();
				app.persistQueue();
				//recurse to work on next item
				app.processQueue(true);
				return;
			}
			, function(jqXHR, textStatus, errorThrown){
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.processQueue > session rating');
				console.error('Error during queue processing [evals]', jqXHR.responseText);
				app.sendQueue.state = null;
			}
		);
	}
	else if (item.type === 'tracking'){
		//send to stats tracking resource
		if (item.location.length === 0){
			//throw away the bad click reference
			app.sendQueue.queue.shift();
			app.persistQueue();
			//recurse
			return app.processQueue(true);
		}
		api.post(
			'/click'
			, {
				deviceId: item.deviceId
				, location: item.location
				, clickTime: item.clickTime
				, meta: item.meta
			}
			, function(data, textStatus, jqXHR){
				//drop the first element in the queue
				app.sendQueue.queue.shift();
				app.persistQueue();
				//recurse to work on next item
				return app.processQueue(true);
			}
			, function(jqXHR, textStatus, errorThrown){
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.processQueue > click tracking');
				console.error('Error during queue processing [click tracking]', '[' + textStatus + ']' + jqXHR.responseText);
				app.sendQueue.state = null;

				//if the error is in the 4xx range, it's shitty code in the app causing this, so throw away the request to prevent infinite-reporting
				if (jqXHR.status >= 400 && jqXHR.status < 500){
					app.sendQueue.queue.shift();
					app.persistQueue();
					return app.processQueue(true);
				}
			}
		);
	}
	else if (item.type === 'streamMsg'){
		api.post(
			'/activity.json'
			, {
				deviceId: item.deviceId
				, msg: item.msg
			}
			, function(data, textStatus, jqXHR){
				app.sendQueue.queue.shift();
				app.persistQueue();
				$.mobile.loading( 'hide' );
				$.mobile.changePage('#stream');
				app.processQueue(true);
				return;
			}
			, function(jqXHR, textStatus, errorThrown){
				//not sure if we're going to want to keep this -- drop the queued request if response is 4xx.
				if (jqXHR.status < 500 && jqXHR.status >= 400){
					app.sendQueue.queue.shift();
				}

				app.sendQueue.state = null;
				$.mobile.loading( 'hide' );
				$.mobile.changePage('#stream');
				ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.processQueue > post to stream');
				console.error('Error during queue processing [stream msg]', jqXHR.responseText);
			}
		);
	}
}

app.startProcessQueue = function(){
	app.processQueue();//always fire immediately, too. No time like the present!
	app.sendQueueTimer = setInterval(app.processQueue, app.sendQueue.frequency);
};

app.stopProcessQueue = function(){
	if (app.sendQueueTimer !== null){
		clearInterval(app.sendQueueTimer);
		app.sendQueueTimer = null;
	}
};

/**
 * Static pages, including local storage of their data.
 */
app.getPagesList = function(callback){
	app.diskCache.get('static_pages_list', '/static', null, 1000*60*5 /* 5 minutes */, false, function(data){
		callback(data);
	});
};
app.loadStaticPage = function(key, contentCB){
	app.diskCache.get(key, '/static/' + key, null, 1000*60*5 /* 5 minutes */, false, function(data){
		contentCB(data);
	});
};

/**
 * In-App feedback
 */
app.sendFeedback = function(comments, successCB, errorCB){
	api.post(
		'/feedback'
		,{
			comments: comments
			,deviceId: app.info.device_id
		}
		,function(data){
			successCB(data);
		}
		,function(jqXHR, textStatus, errorThrown){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.sendFeedback');
			errorCB(jqXHR, textStatus, errorThrown);
		}
	);
};

/**
 * Camera + Picture Uploads
 */
app.uploadPhoto = function(email, fileURI, caption, lat, lng, successCB, failCB){
	var FT = new FileTransfer();
	var uploadOptions = new FileUploadOptions();
	var uploadPath = api.baseurl + '/photos.json';

	uploadOptions.fileKey = 'photo';
	uploadOptions.fileName = 'photo.jpg';
	// uploadOptions.mimeType = 'image/jpeg';
	uploadOptions.chunkedMode = false; //CF barfs otherwise
	uploadOptions.params = {
		deviceId: app.info.device_id
		,latitude: lat
		,longitude: lng
		,caption: caption
	};

	var win = function(resp){ //resp is a FileUploadResult
		console.log(resp);
		$.mobile.loading('hide');
		return successCB(resp);
	};
	var lose = function(err){
		console.error(err);
		$.mobile.loading('hide');
		ui.fail_handler(err, 'photo upload');
		return failCB(err);
	};

	try {
		$.mobile.loading('show',{
			text: "Uploading photo, please wait...",
			textVisible: true,
			theme: "a"
		});
		FT.upload(fileURI, encodeURI(uploadPath), win, lose, uploadOptions);
	}catch(e){
		ui.fail_handler(e, 'calling FT.upload');
	}
};
app.takePhoto = function(useCamera, successCB, failCB){
	var cameraOptions = {
		quality: 75 //0-100
		, destinationType: Camera.DestinationType.FILE_URI //save the file and give us a file path back
		, sourceType: (useCamera === true) ? Camera.PictureSourceType.CAMERA
													  : Camera.PictureSourceType.PHOTOLIBRARY
		, allowEdit: false
		, encodingType: Camera.EncodingType.JPEG
		, saveToPhotoAlbum: true
		, correctOrientation: true
	};

	navigator.camera.getPicture(
		function camSuccess(file_uri){
			console.log('camera success: ', file_uri);
			return successCB(file_uri);
			// app.uploadPhoto(email, file_uri);
			// toastr.success('Picture saved, starting upload.')
		}
		, function camFail(msg){
			console.error(msg);
			return failCB(msg);
			// toastr.error('Unable to get picture. :(');
		}
		, cameraOptions
	);
}

/**
 * Photo feeds
 */
app.recentPhotos = [];
app.recentPhotosTimerFrequency = 1000 * 60; //60 seconds
app.getPhotos = function(args, successCB, failCB){
	api.get(
		'/photos'
		,args
		,function(data){
			successCB(data);
		}
		,function(jqXHR, textStatus, errorThrown){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getPhotos');
			if (failCB) failCB(jqXHR.responseText);
		}
	);
};

app.getGeo = function(successCB, failCB){
	navigator.geolocation.getCurrentPosition(successCB, failCB);
}

/*
 * initialization / auth / etc
 */

app.requireLogin = function(){
	var e = localStorage.getItem('userEmail');
	var id = localStorage.getItem('device_id');
	var p = localStorage.getItem('personId');
	var socialAccounts = localStorage.getItem('social_accounts');
	if (e === null || id === null || p === null){
		$.mobile.changePage('#login');
		return;
	}
	app.userEmail = e;
	app.info.device_id = id;
	app.personId = p;

	//reload social account data if available
	if (socialAccounts !== null){
		socialAccounts = JSON.parse(socialAccounts);
		social.linkedin.user = socialAccounts.linkedin;
		social.linkedin.declinedGroup = socialAccounts.linkedinGroupDecline;
		social.twitter.user = socialAccounts.twitter;
		social.facebook.user = socialAccounts.facebook;
	}

	//verification step
	api.post(
		'/verify'
		,{ personId: p, deviceId: id }
		,function(data){
			if (!data.approved){
				app.userEmail = '';
				app.info.device_id = '';
				app.personId = '';
				$.mobile.changePage('#login');
			}
		}
		,function(jqXHR, textStatus, errorThrown){
			toastr.error('Error validating your device. Please log in again.');
			app.resetApp();
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.registerDevice');
		});

	return;
};

app.saveSocial = function(){
	var data = {
		linkedin: social.linkedin.user
		,linkedinGroupDecline: social.linkedin.declinedGroup
		,twitter: social.twitter.user
		,facebook: social.facebook.user
	};
	localStorage.setItem('social_accounts', JSON.stringify(data));
};

app.setUserEmail = function(email){
	app.userEmail = email;
	localStorage.setItem('userEmail', email);
};

app.setPersonId = function(personId){
	app.personId = personId;
	localStorage.setItem('personId', personId);
};

app.getParty = function(email, zip, pass, fail){
	api.post(
		'/auth'
		, {
			email: email
			,zip: zip
		}
		, function(data){
			app.setUserEmail(email);
			pass(data);
		}
		, function (jqXHR, textStatus, errorThrown){
			if (jqXHR.status >= 400 && jqXHR.status < 500){
				var response;
				try{
					response = JSON.parse(jqXHR.responseText);
					return fail(response.ERROR);
				}catch(e){
					return fail('Error: ' + jqXHR.responseText);
				}
				return;
			}else if (jqXHR.status >= 500 || (jqXHR.status === 0 && jqXHR.readyState === 0)){
				fail('Oops. Looks like there was a problem on our end! Please try again later...');
			}
		}
	);
};

app.registerDevice = function(personId, pass, fail){
	var platform, version, model, uuid, that = this;
	if (typeof(window.device) !== "undefined"){
		platform = window.device.platform;
		model = window.device.model;
		version = window.device.version;
		uuid = window.device.uuid;
	} else {
		platform = 'browser';
		model = navigator.userAgent;
		version = '';
		uuid = '';
	}
	api.post(
		'/registerDevice.json'
		, {
			personId: personId
			,platform: platform
			,model: model
			,version: version
			,uuid: uuid
		}
		, function(data){
			app.info.device_id = data;
			app.setPersonId(personId);
			localStorage.setItem('device_id', data);
			console.log('device registered: ', data);
			app.enableStuff();
			pass(data);
			app.trackClick("Login");
		}
		, function(jqXHR, textStatus, errorThrown){
			console.log('register device failed');
			if (jqXHR.status === 404){
				fail("Email not found or zip didn't match.");
				return;
			}
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.registerDevice');
			fail("Error: [" + errorThrown + "] " + jqXHR.responseText);
		}
	);
};

/*
 * GEOLOCATION REWARDS (BEACONS)
 */
app.beacons = {};
app.getGeoRewards = function(callback){
	api.get(
		'/georewards'
		, {
			deviceId: app.info.device_id
		}
		, function(data){
			callback(data);
		}
		, function(jqXHR, textStatus, errorThrown){
			console.log('get beacons list failed');
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.getGeoRewards');
		}
	);
};
app.redeemBeacon = function(guid, cb){
	api.put(
		'/georewards/'+guid+'/'+app.info.device_id
		,null
		,function(data){
			if (cb){
				cb(true);
			}
		}
		,function(jqXHR, textStatus, errorThrown){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.redeemBeacon');
			cb(false);
		}
	);
};
app.logBeaconProx = function(guid){
	api.post(
		'/georewards/'+guid+'/'+app.info.device_id
		,null
		,function(){}
		,function(jqXHR, textStatus, errorThrown){
			ui.fail_handler(jqXHR.responseText + '; ' + errorThrown, 'app.logBeaconProx');
		}
	);
};

/*
 * CLICK TRACKING
 */

app.trackClick = function(location){
	if (app.disabled) { console.log('disabled; aborting click-track'); return; } //do not attempt click-tracking when app is in offline mode
	if (app.info.hasOwnProperty('device_id')){
		console.log('tracking click: ', location);
		app.queueTracking(app.info.device_id, location);
	} else {
		console.log("device not registered; can't log analytics! :( [" + location + "]");
	}
};

/*
 * ERROR REPORTER
 */
app.reportError = function(msg, detail, success, fail){
	api.post(
		'/buglog'
		, {
			message: msg
			, detail: detail
		}
		, success
		, fail
	);
};

/*
 * RESET APP
 */
app.resetApp = function(){
	app.diskCache.nukeCache();
	app.beacons.antenna.off(); //clear downloaded beacon data and turn off ranging
	localStorage.clear();
	app.requireLogin();
	social.twitter.user = null;
	social.linkedin.user = null;
	social.facebook.user = null;

	social.twitter.displayUser(null);
	social.linkedin.displayUser(null);
	social.facebook.displayUser(null);
};

/*
 * PHONEGAP EVENT HANDLERS
 */
app.enableStuff = function(){
	if (!app.hasOwnProperty('info') || !app.info.hasOwnProperty('device_id')) return;
	app.disabled = false;

	//restart the network queue
	app.stopProcessQueue();
	app.startProcessQueue();

	//restart the next-up timer
	ui.mySchedule.stopNextUpTimer();
	ui.mySchedule.startNextUpTimer();
	ui.mySchedule.nextUp();

	//initialize social plugins
	social.twitter.init();
	social.linkedin.init();
	// social.facebook.init();

	//restart the announcement updater
	app.getAnnouncements();
	clearInterval(app.announcementTimer);
	app.announcementTimer = setInterval(app.getAnnouncements, app.announcementTimerFrequency);

	ui.gallery.prepend();
	clearInterval(app.recentPhotosTimer);
	app.recentPhotosTimer = setInterval(ui.gallery.prepend, app.recentPhotosTimerFrequency);

	//BEACONS!
	try {
		app.beacons.antenna = new CMSEstimote(true);
		app.getGeoRewards(function(rewards){
			app.beacons.beacons = rewards;
			_.each(rewards, function(reward){
				app.beacons.antenna.notifyNear(
					{
						id: reward.BeaconGuid
						,notificationTitle: reward.NotificationTitle
						,notificationBody: reward.NotificationBody
					}
					,function(id, state, json){
						_.each(app.beacons.beacons, function(beacon){
							if (beacon.BeaconGuid === id){
								ui.displayGeoReward(beacon);
							}
						});
					}
					//action on beacon found: log proximity
					,function(id){
						console.log('Beacon Proximity Detected: %s', id);
						// disable api logging of proximity: cornell has privacy concerns
						// app.logBeaconProx(id);
					}
				);
			});
		});
	}catch(e){
		console.error(e);
		console.error('CMSEstimote loading failed');
	}

};

app.disableStuff = function(){
	app.disabled = true;

	//stop the network queue
	app.stopProcessQueue();

	//stop the next-up timer
	ui.mySchedule.stopNextUpTimer();

	//stop the announcement updater
	clearInterval(app.announcementTimer);
	app.announcementTimer = null;

	//stop recent photos timer
	clearInterval(app.recentPhotosTimer);
	app.recentPhotosTimer = null;
};

/*
 * STARTUP
 *
 * Let's keep this as lightweight as possible, eh?
 */

$(function(){

	//emulate phonegap for testing in browsers
	if (!isPhonegap()){
		app.requireLogin();
		app.enableStuff();
	}

});

//this is where we register cordova event listeners
document.addEventListener("deviceready", function(){

	window.deviceReadyCalled = true;

	if (isIOS()){
		$("body").addClass('ios');
	}
	if (isAndroid()){
		$("body").addClass('android');
	}

	//change webview background color to white so that native controls like datepicker and select picker
	//have a white background instead of dark gray.
	setTimeout(function(){
		window.plugins.webviewcolor.change('#FFFFFF');
	}, 1000);

	//handle all relevant phonegap events
	document.addEventListener("offline", app.disableStuff, false);
	document.addEventListener("pause",   app.disableStuff, false);

	document.addEventListener("online",  app.enableStuff, false);
	document.addEventListener("resume",  app.enableStuff, false);

	app.requireLogin();
	app.enableStuff();

}, false);

//check facebook status on resume in case we're coming back from fb login
document.addEventListener("resume", function(){
	if (!social.facebook.facebook) return;
	social.facebook.facebook.getLoginStatus(function( loggedIn ){
		if ( loggedIn ){
			social.facebook.onLogin();
		}
	});
}, false);
